# work in progress! first refactor (surely will change number and names of methods in plugin.py)
# 16.3.2009
# does work separated functions, all together in the test suite the first works the others fail like this
#======================================================================
#ERROR: testRcallSeparated (__main__.RcallTestCase)
#----------------------------------------------------------------------
#Traceback (most recent call last):
#  File "test_plugin.py", line 77, in testRcallSeparated
#    shapefilelist = Rcall(self.geomData, self.opt)
#  File "/home/anne/src/HomeRange_plugin/HRplugin_algorithm.py", line 66, in Rcall
#    data = r_cast_dataframe(QData)
#  File "/home/anne/src/HomeRange_plugin/HRplugin_algorithm.py", line 115, in r_cast_dataframe
#    PythonData["ID"] = robjects.StrVector(PythonData["ID"])
#  File "/usr/lib/python2.5/site-packages/rpy2/robjects/__init__.py", line 294, in __init__
#    obj = rinterface.StrSexpVector(obj)
#  File "/usr/lib/python2.5/site-packages/rpy2/rinterface/__init__.py", line 73, in __init__
#    super(StrSexpVector, self).__init__(v, STRSXP)
#TypeError: argument 2 must be bool, not int

import unittest
import os,sys 
import inspect
import sets
from tempfile import gettempdir
sys.path.append('/home/anne/src/HomeRange_plugin')
from HRplugin_dialog import Rwrapper 

import rpy2.robjects as robjects
#import rpy2.rpy_classic as rpy

# test case
class RcallTestCase(unittest.TestCase):
  idDict = [1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1] # 20 times
  xDict = [1560677,1560708,1560631,1560657,1560670,1560688,1560671,1560644,1560595,1560637,1560625,1560513,1560623,1560484,1560535,1560561,1560597,1560593,1560636,1560592]
  yDict = [5109720,5109611,5109599,5109632,5109634,5109560,5109610,5109466,5109632,5109619,5109478,5109426,5109507,5109508,5109431,5109531,5109489,5109467,5109512,5109466]
  geomData = {'ID':  idDict, 'X': xDict,  'Y': yDict}
  # 
  tempfolder = gettempdir()
# dictionary of methods. Add new methods here as keys, value is its full name.
  mth = {"mcp":"MCP", "href":"Kernel h ref", "lscv":"Kernel h LSCV", "hadj":"Kernel with adjusted h"}
  
  opt = {}
  # input settings
  opt["io"] = {}
  opt["io"]["layer"] = "Arvicola_lula20090323162314383"
  opt["io"]["layerpointer"] = None
  opt["io"]["layername"] = "arvicola"
  opt["io"]["subset"] = "TABLE"
  # specific analysis settings.
  # for each (visible and) checked box, do analysis. Even if user doesn't touch them, a valid analysis can be run
  # using defaults.
  opt["methods"] = {}
  for i in mth:
      opt["methods"][i] = {}
      opt["methods"][i]["percent"] = 95
  # output settings
  opt["io"]["outputfolder"] = tempfolder
  opt["io"]["overwrite"] = True
  opt["io"]["outputview"] = False  
  
  def testRcallGlobal(self):
    self.opt["io"]["mode"] = "global"
    rwrapper = Rwrapper()    
    shapefilelist = rwrapper.Rcall(self.geomData, self.opt)
    expectedshapefilelist = ['arvicola-hlscv-95', 'arvicola-hadj-95', 'arvicola-href-95', 'arvicolaMCP95all']
    self.assertEquals(shapefilelist,  expectedshapefilelist)
    
  def testRcallSeparated(self):
    self.opt["io"]["mode"] = "separated"
    rwrapper = Rwrapper()
    shapefilelist = rwrapper.Rcall(self.geomData, self.opt)
    expectedshapefilelist = ['arvicola-hlscv-95-1', 'arvicola-hadj-95-1', 'arvicola-href-95-1']
    self.assertEquals(shapefilelist,  expectedshapefilelist)
    
  def testRcallGlobalSeparated(self):
    self.opt["io"]["mode"] = "global, separated"
    rwrapper = Rwrapper()
    shapefilelist = rwrapper.Rcall(self.geomData, self.opt)
    expectedshapefilelist = ['arvicola-hlscv-95-1', 'arvicola-hadj-95-1', 'arvicola-href-95-1','arvicola-hlscv-95', 'arvicola-hadj-95', 'arvicola-href-95', 'arvicolaMCP95all']
    self.assertEquals(shapefilelist,  expectedshapefilelist)

def suite():
    suite = unittest.TestLoader().loadTestsFromTestCase(RcallTestCase)
    return suite
# run it
if __name__ == '__main__':
    unittest.main()
